function [obj] = IIFun(par,p, o, q, W, beta_hat,FUNC, Eta_y,T,M,H,D)
%% Indirect INferece simulation
 P0=100;  % price at t=0 

%% Parameters 
kappa_1=(par(1)); % TFSV model speed of mean reversion 1
kappa_2=(par(1)); % TFSV model speed of mean reversion 2
omega=(par(2));   % mean of SV
eta_1=(par(3));   % TFSV model vol-of-vol 1
eta_2=(par(3));   % TFSV model vol-of-vol 2
sigma_nu=par(4); % variance of the noise
phi=par(5); % Mean jump term
% sigma_nu = par(8); % variance of jump term
lambda = par(6); % jump frequency
rho = par(7); % leverage parameter

params=[kappa_1,kappa_2,omega,eta_1,eta_2,phi]; % parameters of the SDE
sampling=12*5; % 5 minutes sub-sampling
cons = 1/((M/sampling)-1):1/((M/sampling)-1):((M/sampling)/((M/sampling)-1));
for j=1:H
    w=W(:,:,j); % innovations
    [r]=simulate_heston_two_factors(T,M,params,1,w(:,1),w(:,2),w(:,3),w(:,4)); % generate (percentage) log-returns
    
k_t = phi+sqrt(sigma_nu)*w(:,5);

% Jump component: J_t = 1(U[0,1]<lambda*delta)*ln(1+k_t)
nu = (w(:,6)<lambda*(1/D)).*k_t;
nu=reshape(nu,M,T);
    
    
     r_n=r+nu;  % add the noise to the log-return at the 5-second frequency
    RV_5_sec=sum(r_n.^2)'; % construct RV at 5 seconds
    p=log(P0)+cumsum(reshape(r/100,M*T,1)); % generate log-prices
    p_D=reshape(p(1:sampling:end),M/sampling,T); % subsampling of log-prices
    r_D=reshape([zeros(1,T);diff(p_D)],M/sampling,T)*100; % add noise to sub-sampled returns 
    RV_5_min=sum(r_D.^2)';  % construct RV at 5 minutes 

BVi = abs(r_D).*abs([zeros(size(r_D,1),1) r_D(:,1:end-1)]).*(pi/2).*(cons'*ones(1,T));
BVt=sum(BVi)';

jT = (RV_5_min - BVt).*((RV_5_min-BVt)>0);

% Daily returns 
    p_Da=reshape( p(1:M:end),T,1); % subsampling of log-prices
    r_Da=reshape([0;diff(p_Da)],T,1)*100; % add noise to sub-sampled returns 
%     r_Da = r_Da(2:end);

% Stats
eta1_z = (sign(r_Da).*sqrt(jT));
eta2_z = (jT-mean(jT)).^2;
eta3_z = ((jT-mean(jT)).*[0;(jT(1:end-1)-mean(jT))]);

[sc_sim,H_sim] = tarch_scores_all(r_Da(2:end), 1, 0,1, 2, 2, beta_hat);

MoM_1(:,:,j) = (sc_sim) - ones(length(sc_sim),length(beta_hat))*H_sim*(FUNC-beta_hat);
MoM_2(:,:,j) = [eta1_z-Eta_y(1), eta2_z-Eta_y(2) eta3_z-Eta_y(3)];


end;

mom_1 = sum(MoM_1,3)./H;
mom_2 = sum(MoM_2,3)./H;

MoM = [mom_1 mom_2(2:end,:)];

mat = inv(cov(MoM));
 obj = mean(MoM)*mean(MoM)';
















 